require 'json'

module Sprintly
  class Product
    WHITELISTED_ATTRIBUTES = [
      "archived", "name", "admin",
      "created_at", "webhook", "email", "id"
    ].freeze

    def self.all
      response = Sprintly::Connection.get("products.json")
      raw_products = JSON.parse(response.body)
      raw_products.map { |raw_product| new(raw_product) }
    end

    def initialize(raw_product)
      WHITELISTED_ATTRIBUTES.each do |attr|
        if raw_product.has_key?(attr)
          instance_variable_set("@#{attr}", raw_product[attr])
          singleton_class.class_eval do
            attr_reader "#{attr}"
          end
        end
      end
    end

    def get_items_by_status(status)
      items = Sprintly::Item.for_product(self.id)
      items.select { |item| item.status == status }
    end

  end
end